<template>
<div class="ml-2 mr-2">
        <page-header title="Nouvelle Voiture">

            <div slot="nav">
                <ol class="breadcrumb float-sm-right">
                       <li class="breadcrumb-item">
                           <router-link to="/voitures" class="">Voitures</router-link >
                        </li>
                       <li class="breadcrumb-item active">Nouvelle Voiture</li>
                </ol>
            </div>
        </page-header>
                <div class="col-md-12">

        <div :class="['card bg-transparent content-card']" >
               <div :class="['card-header content-card-title pl-0']">
                    <h3 class="card-title pl-2">
                        Formulaire de création
                    </h3>

                 <div class="card-tools">

                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body content-card-body pl-4 pr-4 " style="background:white !important">
                    <form class=""
                            method="POST"  @submit.prevent="onSubmit()"  @reset.prevent="reset()" @keydown=" updateFormErrors($event.target.name)" @change="updateFormErrors($event.target.name)">


                                <form-wizard ref="wizard" shape="circle" color="#343a40a1" @on-loading="setLoading"  @on-change="updateStep" @on-complete="onComplete">
                                        <template slot="step" slot-scope="props">
                                                <wizard-step :tab="props.tab"
                                                :transition="props.transition"
                                                :key="props.tab.title"
                                                :index="props.index">
                                                </wizard-step>
                                            </template>
                                        <tab-content title="Données Générales" :before-change="carStoreStep">
                                            <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Nom de code *</label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="libelle" v-model="form.libelle" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('libelle')" v-text="form.errors.get('libelle')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState2">Prix de la location quotidienne *</label>
                                                        <input id="inputState2" class="form-control form-control-md form-custom-input-sm" name="tarif" v-model="form.tarif" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('tarif')" v-text="form.errors.get('tarif')"></span>

                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label >Date de mise en circulation *</label>
                                                        <vc-date-picker datePicker.popover.placement="bottom"   @input="datepickerEvent" :masks="mask" mode="single" v-model="date_pmc" class="ml-1"></vc-date-picker>

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_mise_en_circulation')" v-text="form.errors.get('date_mise_en_circulation')"></span>

                                                    </div>
                                            </div>
                                            <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Marque *</label>
                                                        <!-- <select id="inputState"  class="form-control form-control-md form-custom-input-sm" name="marque_id" v-model="form.marque_id" type="text">
                                                            <option value="">Choisissez svp</option>
                                                            <option>...</option>
                                                        </select> -->

                                                        <multi-select @input="trackMarque" name="marque_id"
                                                        v-model="marque" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Choisissez la marque"
                                                        :options="opt.marques"   label="libelle" track-by="id">

                                                                <!-- <template><span slot="noOptions">Aucune route disponible</span></template> -->

                                                        </multi-select>

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('marque_id')" v-text="form.errors.get('marque_id')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label class="">Modèle *</label>
                                                        <multi-select @input="trackModele" :disabled="!Modeles.length>0"
                                                        v-model="modele" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Choisissez le modele"
                                                        :options="Modeles"   label="libelle" track-by="id">


                                                        </multi-select>

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('modele_id')" v-text="form.errors.get('modele_id')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState4">Type de la voiture * <small>(Forme)</small></label>
                                                        <multi-select
                                                                no-ptions="Aucun type de véhicule disponible" open-direction="bottom" name="type_vehicule_id"
                                                                v-model="tvehicule"  :options="opt.tvehicules"
                                                                @input="tvehicules => tvehicule!=null  ? form.type_vehicule_id = tvehicule.id : form.type_vehicule_id = ''"
                                                            :show-labels="false" :searchable="true" :clear-on-select="false"
                                                            :close-on-select="true"  placeholder="Le type de voiture" label="libelle" track-by="id" >
                                                        </multi-select>
                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('type_vehicule_id')" v-text="form.errors.get('type_vehicule_id')"></span>

                                                    </div>
                                            </div>
                                            <div class="form-row">


                                            </div>
                                            <div class="form-row">
                                                            <div class="form-group col-md-4">
                                                                <label class="">Type de motorisation</label>

                                                                <multi-select
                                                                    no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                                    v-model="motorisation"  :options="opt.motorisations"
                                                                    @input="motorisations => motorisation!=null  ? form.type_motorisation_id = motorisation.id : form.type_motorisation_id = null"
                                                                    :show-labels="false" :searchable="true" :clear-on-select="false"
                                                                    :close-on-select="true"  placeholder="Type de motorisation" label="libelle" track-by="id">
                                                                </multi-select>
                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('type_motorisation_id')" v-text="form.errors.get('type_motorisation_id')"></span>
                                                            </div>
                                                            <div class="form-group col-md-4">
                                                                <label for="inputState">Boite de vitesse * <small>(Forme)</small></label>
                                                                <multi-select
                                                                    no-ptions="Aucun revendeur disponible" open-direction="bottom" name="boite_vitesse"
                                                                    v-model="form.boite_vitesse"  :options="['Automatique','Manuelle']"
                                                                    :show-labels="false" :searchable="true" :clear-on-select="false"
                                                                    :close-on-select="true"  placeholder="Boite de vitesse" >
                                                                </multi-select>
                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('boite_vitesse')" v-text="form.errors.get('boite_vitesse')"></span>

                                                            </div>
                                                            <div class="form-group col-md-4">
                                                                <label class="">Consommation au 100 km *</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="consommation_au_100_km" v-model="form.consommation_au_100_km" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('consommation_au_100_km')" v-text="form.errors.get('consommation_au_100_km')"></span>
                                                            </div>
                                            </div>
                                            <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Etat du kilométrage *</label>
                                                        <input id="inputState6" class="form-control form-control-md form-custom-input-sm" name="kilometrage" v-model="form.kilometrage" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('kilometrage')" v-text="form.errors.get('kilometrage')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState7">Plaque d'immatriculation *</label>
                                                        <input id="inputState7" class="form-control form-control-md form-custom-input-sm" name="plaque_immatriculation" v-model="form.plaque_immatriculation" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('plaque_immatriculation')" v-text="form.errors.get('plaque_immatriculation')"></span>

                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label class="">N° de chassis </label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="nr_chassis" v-model="form.nr_chassis" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('nr_chassis')" v-text="form.errors.get('nr_chassis')"></span>
                                                    </div>

                                            </div>
                                            <div class="form-row">
                                                    <div class="form-group col-md-4">
                                                        <label class="">Nombre de porte *</label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="nbr_porte" v-model="form.nbr_porte" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('nbr_porte')" v-text="form.errors.get('nbr_porte')"></span>
                                                    </div>
                                                    <div class="form-group col-md-4">
                                                        <label for="inputState1">Nombre de place *</label>
                                                        <input id="inputState1" class="form-control form-control-md form-custom-input-sm" name="nbr_place" v-model="form.nbr_place" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('nbr_place')" v-text="form.errors.get('nbr_place')"></span>

                                                    </div>

                                                    <div class="form-group col-md-4">
                                                        <label class="">Couleur *</label>
                                                        <input  class="form-control form-control-md form-custom-input-sm" name="couleur" v-model="form.couleur" type="text" />

                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('couleur')" v-text="form.errors.get('couleur')"></span>
                                                    </div>
                                            </div>
                                        </tab-content>
                                        <tab-content title="Options & Mesures" :before-change="carStoreStep">
                                                        <div class="form-row">
                                                            <div class="form-group col-md-12">
                                                                <label class="">Options de sécurité</label>
                                                                    <multi-select
                                                                        no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                                        v-model="securites"  :options="opt.optSecurite" :multiple="true" :taggable="true" @tag="addSecuriteOpt"
                                                                        :show-labels="false" :searchable="true" :clear-on-select="false"
                                                                        :close-on-select="true"  placeholder="Choisissez les options de sécurité" label="libelle" track-by="id">
                                                                    </multi-select>
                                                                <span class="m-form__help m--font-danger" ></span>
                                                            </div>
                                                            <div class="form-group col-md-12">
                                                                <label class="">Options de confort</label>
                                                                    <multi-select
                                                                        no-ptions="Aucun revendeur disponible" open-direction="bottom" name="options.*.id "
                                                                        v-model="conforts"  :options="opt.optConfort" :multiple="true" :taggable="true"
                                                                        :show-labels="false" :searchable="true" :clear-on-select="false"
                                                                        :close-on-select="true"  placeholder="Choisissez les options de confort" label="libelle" track-by="id">
                                                                    </multi-select>
                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('options.*.id')" v-text="form.errors.get('options.*.id')"></span>
                                                            </div>
                                                            <div class="form-group col-md-12">
                                                                <label class="">Options de plaisir</label>
                                                                    <multi-select
                                                                        no-ptions="Aucun revendeur disponible" open-direction=" bottom"
                                                                        v-model="plaisirs"  :options="opt.optPlaisir" :multiple="true" :taggable="true"
                                                                        :show-labels="false" :searchable="true" :clear-on-select="false"
                                                                        :close-on-select="true"  placeholder="Choisissez les options de plaisir" label="libelle" track-by="id">
                                                                    </multi-select>
                                                                <span class="m-form__help m--font-danger"  ></span>
                                                            </div>
                                                        </div>
                                                    <div class="form-row">
                                                            <div class="form-group col-md-6">
                                                                <label class="">Volume du réservoir (En Litre)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="volume_reservoir" v-model="form.volume_reservoir" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('volume_reservoir')" v-text="form.errors.get('volume_reservoir')"></span>
                                                            </div>
                                                            <div class="form-group col-md-6">
                                                                <label class="">Volume du coffre (En Litre)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="volume_coffre" v-model="form.volume_coffre" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('volume_coffre')" v-text="form.errors.get('volume_coffre')"></span>
                                                            </div>
                                                    </div>

                                                    <div class="form-row">
                                                            <div class="form-group col-md-3">
                                                                <label class="">Longueur (En m)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="longueur" v-model="form.longueur" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('longueur')" v-text="form.errors.get('longueur')"></span>
                                                            </div>
                                                            <div class="form-group col-md-3">
                                                                <label class="">Largeur (En m)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="largeur" v-model="form.largeur" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('largeur')" v-text="form.errors.get('largeur')"></span>
                                                            </div>
                                                            <div class="form-group col-md-3">
                                                                <label class="">Hauteur (En m)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="hauteur" v-model="form.hauteur" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('hauteur')" v-text="form.errors.get('hauteur')"></span>
                                                            </div>
                                                            <div class="form-group col-md-3">
                                                                <label class="">Poids (En Kg)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="poids" v-model="form.poids" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('poids')" v-text="form.errors.get('poids')"></span>
                                                            </div>
                                                        </div>
                                        </tab-content>
                                        <tab-content title="Galerie" :before-change="carStoreStep">
                                            <div class="d-flex justify-content-between">
                                                    <div class="">
                                                        <h4 class="bold mt-2">Image de mise en Avant</h4>
                                                        <div class="image-uploader-content profile-image-preview mb-2" style="border:dashed 4px #ccc">
                                                            <img src="/img/default.jpg" alt="" class="img-fluid">
                                                        </div>
                                                        <div  :class="['file is-fullwidth mt-2  is-disable']">
                                                            <label class="file-label">
                                                                <input class="file-input" @change="readURL" type="file" name="image_mise_en_avant" accept="image/x-png,image/gif,image/jpeg">
                                                                <span class="file-cta w-100">
                                                                <span class="file-icon">
                                                                    <div v-if="imageProfileIsLoading" class="kt-spinner kt-spinner--v2 kt-spinner--danger ml-2 "></div>
                                                                    <i class="fas fa-camera mr-2" v-else ></i>
                                                                </span>
                                                                <span class="file-label">
                                                                    Charger l'image de profil
                                                                </span>
                                                                </span>
                                                            </label>
                                                        </div>
                                                    </div>
                                                    <div class="w-100">
                                                        <!-- <span class="" >
                                                            <div class="file mr-3 d-inline-block">
                                                                <label class="file-label">
                                                                    <input ref="file-images" class="file-input" @change="readURLGalerie" type="file" name="images[]" accept="image/x-png,image/gif,image/jpeg" multiple>
                                                                    <span class="file-cta w-100">
                                                                    <span class="file-icon">
                                                                        <div v-if="imageGalleryIsLoading" class="kt-spinner kt-spinner--v2 kt-spinner--danger ml-2 "></div>
                                                                        <i class="fas fa-upload mr-2" v-else ></i>

                                                                    </span>
                                                                    <span class="file-label">
                                                                        Ajouter des images à la galerie
                                                                    </span>
                                                                    </span>
                                                                </label>
                                                            </div>
                                                        </span> -->
                                                        <div class="image-gallery-content d-flex align-content-between m-2 flex-wrap">
                                                                <!-- <div class="box-image" v-for="(src,index) in form.images" :key="index" >
                                                                    <img :src="src" alt="" />
                                                                    <div class="box-overlay"></div>
                                                                    <div class="button"><a @click.prevent=removeImage(index)> Supprimer </a></div>
                                                                </div> -->
                                                                <vue-dropzone ref="dropzone"
                                                                 @vdropzone-max-files-reached="maxFilesReached"
                                                                 @vdropzone-removed-file="removedfileFromDropzone"
                                                                 @vdropzone-file-added="fileAdded" @vdropzone-success="registerFile" :duplicate-check="true"
                                                                  id="dropzone" :options="dropzoneOptions">
                                                                </vue-dropzone>
                                                        </div>
                                                    </div>
                                            </div>

                                        </tab-content>
                                        <tab-content title="Récapitulatif" icon="fa  fa-check" :before-change="carStoreStep">
                                            <div class="card no-border" style="border: none;box-shadow: none;" v-if="lastStep">
                                                <div class="card-header bg-transparent">
                                                    <h3 class="card-title">En bref</h3>

                                                </div>
                                                <!-- /.card-header -->
                                                <div class="card-body  p-0">
                                                    <table class="table   text-nowrap">

                                                        <tbody>
                                                            <tr>
                                                                <td class="text-bold">Nom de code</td>
                                                                <td>{{form.libelle}}</td>
                                                                <td class="text-bold">Prix de la location</td>
                                                                <td>{{form.tarif}} F cfa / jour</td>
                                                                <td class="text-bold">Type de la voiture</td>
                                                                <td>{{ tvehicule.libelle}}</td>
                                                            </tr>
                                                            <tr>
                                                                <td class="text-bold">Marque</td>
                                                                <td>{{ marque.libelle}}</td>
                                                                <td class="text-bold">Modele</td>
                                                                <td>{{ modele.libelle}}</td>
                                                                <td class="text-bold">Couleur</td>
                                                                <td>{{ form.couleur}}</td>
                                                            </tr>
                                                            <tr>
                                                                <td class="text-bold">Consommation aux 100 km</td>
                                                                <td>{{ form.consommation_au_100_km}}</td>
                                                                <td class="text-bold">Energie</td>
                                                                <td>{{ motorisation.libelle}}</td>
                                                                <td class="text-bold">Type de transmission</td>
                                                                <td>{{ form.boite_vitesse}}</td>
                                                            </tr>
                                                            <tr>
                                                                <td class="text-bold">kilometrage</td>
                                                                <td>{{ form.kilometrage}} km</td>
                                                                <td class="text-bold">Plaque d'immatriculation</td>
                                                                <td>{{ form.plaque_immatriculation}}</td>
                                                                <td class="text-bold">N° de chassis</td>
                                                                <td>{{ form.nr_chassis}}</td>
                                                            </tr>
                                                            <tr>
                                                                <td class="text-bold">Nombre de porte</td>
                                                                <td>{{ form.nbr_porte}}</td>
                                                                <td class="text-bold">Nombre de place</td>
                                                                <td>{{ form.nbr_place}}</td>
                                                                <td class="text-bold">Volume du réservoir</td>
                                                                <td v-if="form.volume_reservoir!=''">{{ form.volume_reservoir}} L</td>
                                                                <td v-else></td>
                                                            </tr>
                                                            <tr>
                                                                <td class="text-bold">Volume du coffre</td>
                                                                <td v-if="form.volume_coffre!=''">{{ form.volume_coffre}} L</td>
                                                                <td v-else></td>
                                                                <td class="text-bold">Poids</td>
                                                                <td v-if="form.poids!=''">{{ form.poids}} Kg</td>
                                                                <td v-else></td>
                                                                <td class="text-bold">Dimensions (L x l x H ) en m</td>
                                                                <td>{{ form.longueur!='' ? form.longueur : 'R.A.S'}} x {{ form.largeur!='' ? form.largeur : 'R.A.S'}} x {{ form.hauteur!='' ? form.hauteur : 'R.A.S'}} </td>
                                                            </tr>
                                                            <tr v-if="securites.length>0">
                                                                <td class="text-bold">Options de sécurité</td>
                                                                <td colspan="5">
                                                                    <span  v-for="(s,index) in securites" :key="index" class="multiselect__tag"><span v-text="s.libelle"></span> <i aria-hidden="true" tabindex="1" class="multiselect__tag-icon"></i></span>
                                                                </td>
                                                            </tr>
                                                            <tr v-if="conforts.length>0">
                                                                <td class="text-bold">Options de confort</td>
                                                                <td colspan="5">
                                                                    <span  v-for="(s,index) in conforts" :key="index" class="multiselect__tag"><span v-text="s.libelle"></span> <i aria-hidden="true" tabindex="1" class="multiselect__tag-icon"></i></span>
                                                                </td>

                                                            </tr>
                                                            <tr v-if="plaisirs.length>0">
                                                                <td class="text-bold">Options de plaisir</td>
                                                                <td colspan="5">
                                                                   <span  v-for="(s,index) in plaisirs" :key="index" class="multiselect__tag"><span v-text="s.libelle"></span> <i aria-hidden="true" tabindex="1" class="multiselect__tag-icon"></i></span>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>

                                                    <!-- Tabs -->
                                                    <div class="card card-primary card-outline card-outline-tabs" style=" margin-top: 10px;" v-if="hasImages">
                                                        <div class="card-header p-0 border-bottom-0">
                                                            <ul class="nav nav-tabs" id="custom-tabs-three-tab" role="tablist">
                                                                <li class="nav-item">
                                                                    <a class="nav-link active" id="custom-tabs-three-home-tab" data-toggle="pill" href="#custom-tabs-three-home" role="tab" aria-controls="custom-tabs-three-home" aria-selected="true">Galerie</a>
                                                                </li>
                                                            </ul>
                                                        </div>
                                                        <div class="card-body">
                                                            <div class="tab-content" id="custom-tabs-three-tabContent">
                                                                <div class="tab-pane fade active show" id="custom-tabs-three-home" role="tabpanel" aria-labelledby="custom-tabs-three-home-tab">
                                                                    <div class="row">
                                                                         <div class="col-md-4 col-sm-12">
                                                                             <!-- Row profil-->
                                                                                    <div class="card mb-4 shadow-sm">
                                                                                         <div class="card-body profile-image-preview">
                                                                                               <img v-if="form.image_mise_en_avant!=''" :src="form.image_mise_en_avant" alt="preview de votre image de profil">
                                                                                               <img v-else src="/img/default.jpg" alt="Aucune image de profil" class="img-fluid">
                                                                                         </div>
                                                                                    </div>
                                                                             <!-- /Row profil -->
                                                                         </div>
                                                                         <div class="col-md-8 col-sm-12">
                                                                             <div class="row">
                                                                                 <!-- Galerie -->
                                                                                       <div class="preview-end-gallery" v-for=" (image,index) in form.images" :key="index">
                                                                                                    <img :src="image" :alt="'preview-'+index">
                                                                                       </div>
                                                                                <!-- /galerie -->
                                                                             </div>
                                                                         </div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <!-- /.card -->
                                                    </div>
                                                    <!-- /.card-body -->
                                                </div>
                                                <!-- /.card-body -->
                                            </div>
                                        </tab-content>
                                        <template slot="footer" slot-scope="props">
                                            <div class="wizard-footer-left">
                                            <wizard-button  v-if="props.activeTabIndex > 0 " @click.native="props.prevTab()" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading || FileIsLoading"><i class="la la-arrow-left mr-2"></i> Retour </wizard-button>
                                            </div>
                                            <div class="wizard-footer-right">
                                            <wizard-button v-if="!props.isLastStep" @click.native=" props.nextTab()" class="wizard-footer-right btn btn-block btn-primary btn-lg" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading || FileIsLoading">
                                                <span v-if="!isLoading">
                                                    Suivant <i class="la la-arrow-right ml-2"></i>
                                                </span>
                                                <span v-else class="pr-2">
                                                    <i class="m-loader m-loader--light m-loader--right ml-4 pr-1"></i>
                                                    <span>Chargement</span>
                                                </span>
                                                </wizard-button>

                                            <wizard-button v-else @click.native="onSubmit" class="wizard-footer-right finish-button" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading">

                                                <span v-if="!isLoading">
                                                    Terminer <i class="la la-check ml-2"></i>
                                                </span>
                                                <span v-else class="pr-2">
                                                    <i class="m-loader m-loader--light m-loader--right ml-4 pr-1"></i>
                                                    <span>Chargement</span>
                                                </span>
                                                </wizard-button>
                                            </div>
                                        </template>
                                </form-wizard>
                </form>
              </div>
        </div>
                        </div>

</div>
</template>

<script>
import {FormWizard,WizardButton,WizardStep, TabContent} from 'vue-form-wizard'
import 'vue-form-wizard/dist/vue-form-wizard.min.css'
import Master from "./../Master.vue";
import vue2Dropzone from 'vue2-dropzone'
//component code

   import Form from "./../../classes/Form"
    export default {
        mixins: [Master],
        data()
        {
            return{

                isLoading:false,
                imageProfileIsLoading:false,
                imageGalleryIsLoading:false,
                FileIsLoading:false,
                filesAdded:[],
                modeEdit:false,
                modeles : [],
                FileLimit:4,
                isMounted:false,
                fileCounter:0,
                //VC-calendar
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                },
                date_pmc:"",

                //multi-select
                marque:"",
                modele:"",
                motorisation:"",
                permis:"",
                tvehicule:"",

                //Options selectionnées
                plaisirs : [],
                conforts : [],
                securites : [],

                opt:{
                    marques:[],
                    motorisations:[],
                    tvehicules:[],
                    optConfort:[],
                    optPlaisir:[],
                    optSecurite:[],
                    tpermis:[],
                },
                dropzoneOptions: 
                {
                 url:"/",
                 method:'post',
                 autoQueue:false,
                 thumbnailWidth: 150,
                 acceptedFiles:'image/jpeg,image/jpg,image/png',
                 maxFiles:this.FileLimit,
                 dictCancelUpload:" Annuler ",
                 dictCancelUploadConfirmation:"Supprimer",
                 dictRemoveFile:" Supprimer ",
                 dictDefaultMessage: "<i class='fas fa-cloud-upload-alt mr-2 fa-2x'></i> Glisser ou charger des images  ici pour la galerie de la voiture </br>(4 images maximum)",
                 addRemoveLinks: true,
                 headers: {
          	   	 Authorization: `Bearer ${window.App.api_token}`
        	      },
                },
                labels :
                {
                  title:"Ajout d'un Voiture" ,
                  action:"Ajouter"
                },
                form : new Form(
                    {
                        image_mise_en_avant:"",
                        images:[],
                        marque_id:"",
                        modele_id:"",
                        libelle:"",
                        type_vehicule_id: "",
                        type_permis_id: "",
                        step:0,

                        options:[],

                        nbr_place: "",
                        nbr_porte: "",
                        couleur: "",

                        //tarifs
                        tarif: "",
                        kilometrage: "",

                        //unicités
                        plaque_immatriculation: "",
                        nr_chassis: "",

                        date_mise_en_circulation: "",
                        annee_mise_en_circulation: "",
                        consommation_au_100_km: "",

                        //moteurs
                        type_motorisation_id: "",
                        boite_vitesse: "",

                        //mesures physiques
                        volume_coffre: "",
                        volume_reservoir: "",
                        largeur: "",
                        longueur: "",
                        poids: "",
                        hauteur: ""
                  }),

            }
        },
        computed:
         {
            ModalTitle ()
            {
            return  this.modeEdit ? " Modification d'une Voiture"  : " Ajout d'une Voiture"
            },
            ModalAction ()
            {
            return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            Modeles ()
            {
              if(this.marque==null || this.marque=="")
              return  []
              else
              return this.marque.modeles
            },
            //Determine si le formulaire est à la derniere etape
            lastStep()
            {
              if(this.isMounted==false) return false
              return this.$refs.wizard.isLastStep
            },
            //Determine si le formulaire a des images
            hasImages()
            {
              if(this.form.images.length>0 || this.form.image_mise_en_avant!="")
              return true
              else
              return false
            },
            //Fusions les tableaux d'options
             OptionsPack ()
            {

              var arr = []
              _.merge(arr,[this.securites,this.plaisirs,this.conforts])
              return _.uniq(_.flatten(arr))

            },
            //Recupere les ids des tableaux d'options
             OptionsIds()
            {

              if(this.OptionsPack.length!=0)
              {
                  var arr = this.OptionsPack.map( e => {return e.id});
                  return arr
              }
              else
              return []


            },

        },
        created()
        {
           this.fetchOptions()
        },
        mounted()
         {

             //les options sont chargées
             this.isMounted = true;
              this.$on('initOption', e => {
                this.initForm()


            })
        },
        methods:
        {
            datepickerEvent(event)
            {
                this.form.date_mise_en_circulation = moment(event).format('YYYY-MM-DD')
                this.updateFormErrors("date_mise_en_circulation")
                //this.moreParams.filter_date_fin = moment(periode.end).format('YYYY-MM-DD')
                //Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
             fetchOptions()
             {
               axios.get("/api/dispatcher/options/vehicules").then((response) =>
                {
                      this.opt.marques = response.data.marques.filter( e => {

                       return  e.modeles.length>0
                      })
                      this.opt.motorisations = response.data.motorisations
                      this.opt.tpermis = response.data.tpermis
                      this.opt.tvehicules = response.data.tvehicules

                      response.data.voptions.forEach( e =>
                      {

                        if(e.code == "SEC")
                          this.opt.optSecurite = e.options
                        if(e.code == "CNF")
                         this.opt.optConfort = e.options
                        if(e.code == "PLS")
                         this.opt.optPlaisir = e.options
                      }  )

                      //envoie un event pour signifier le chargement des options
                      this.$emit('initOption');
                      this.pageInit =true
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },

             initForm()
            {
                    this.form.image_mise_en_avant="",
                    this.form. images=[],
                    this.form.marque_id="",
                    this.form.modele_id="",
                    this.form.libelle="",
                    this.form.type_vehicule_id= "",
                    this.form.type_permis_id= "",
                    this.form.type_motorisation_id= "",
                    this.form.step="",

                    this.form.nbr_place= "",
                   this.form. nbr_porte= "",
                   this.form.couleur= "",

                    //tarifs
                    this.form.tarif= "",
                    this.form.kilometrage= "",

                    //unicités
                    this.form.plaque_immatriculation= "",
                    this.form.nr_chassis= "",

                    this.form.date_mise_en_circulation= "",
                    this.date_pmc =""
                    this.form.annee_mise_en_circulation= "",
                    this.form.consommation_au_100_km="",

                    //moteurs

                    this.form.boite_vitesse= "",

                    //mesures physiques
                    this.form.volume_coffre= "",
                    this.form.volume_reservoir= "",
                    this.form.largeur= "",
                    this.form.longueur= "",
                    this.form.poids= "",
                    this.form.hauteur= "",

                    this.marque = ""
                    this.modele = ""
                    this.motorisation = ""
                    this.tvehicule = ""
                    this.plaisirs = [],
                    this.conforts =[],
                    this.securites=[]

            },
            initForm2()
            {
                    this.form.image_mise_en_avant="",
                    this.form. images=[],
                    this.form.marque_id="1",
                    this.form.modele_id="1",
                    this.form.libelle="Puvi express",
                    this.form.type_vehicule_id= 1,
                    this.form.type_permis_id= "",
                    this.form.type_motorisation_id= 2,
                    this.form.step=0,

                    this.form.nbr_place= 5,
                   this.form. nbr_porte= 5,
                   this.form.couleur= "Rouge",

                    //tarifs
                    this.form.tarif= "50000",
                    this.form.kilometrage= 23554,

                    //unicités
                    this.form.plaque_immatriculation= "AZSE-RTDFD",
                    this.form.nr_chassis= "ERDF-ERFFF",

                    this.form.date_mise_en_circulation= "2016-02-05",
                    this.date_pmc = moment(this.form.date_mise_en_circulation).toDate()

                    this.form.annee_mise_en_circulation= "2016",
                    this.form.consommation_au_100_km= 5.5,

                    //moteurs

                    this.form.boite_vitesse= "Automatique",

                    //mesures physiques
                    this.form.volume_coffre= "100",
                    this.form.volume_reservoir= "60",
                    this.form.largeur= "2.4",
                    this.form.longueur= "2.8",
                    this.form.poids= "1290",
                    this.form.hauteur= "1.7",

                    this.marque = this.opt.marques.find(e =>  e.id == this.form.marque_id)
                    this.modele = this.marque.modeles.find(e =>  e.id == this.form.modele_id)
                    this.motorisation = this.opt.motorisations.find(e => e.id == this.form.type_motorisation_id )
                    this.tvehicule = this.opt.tvehicules.find(e =>  e.id == this.form.type_vehicule_id)

            },
            updateFormErrors(name)
            {
                if(this.form.errors.any()==true)
                {
                    //on retire l erreur
                    this.form.errors.clear(name)
                    //on verifie s il  n ya plus d erreurs
                    if(this.form.errors.any()==false)
                    {
                        this.$refs.wizard.tabs[this.form.step].validationError = null
                    }
                }

            },

          //ajout de la voiture par étape
          carStoreStep()
          {

                return new Promise((resolve, reject) => {
                    axios.post('/api/vehicules', this.form.data())
                        .then(response => {

                            resolve(true);
                        })
                        .catch(error => {
                            this.form.onFail(error.response.data);

                            reject(error.response.data);
                        });
                   });
          },
          onSubmit()
           {

                this.isLoading = true
                this.form.post("/api/vehicules").then((response) =>
                {


                         if(response.success)
                         {
                           this.$events.$emit("newCardAdded",response.vehicule)
                           flash("<span>Enregistré <strong>avec succès</strong></span>",'success')
                           this.$router.push('/voitures',{});
                          }
                          else
                          {
                             flash("<span>Enregistrement  <strong>impossible</strong></span>",'error')
                          }
                          this.isLoading = false


                        



                },
                (error) => {

                    this.isLoading = false
                    }

                    );
           },

            updateStep(prevIndex, nextIndex)
            {
                if(!this.form.errors.any())
                {

                  this.form.step = nextIndex
                  this.$forceUpdate()
                }
            },

            setLoading(value)
            {
               this.isLoading = value
            },
            addSecuriteOpt(option)
            {
              console.log(option)
            },
            //Charge l'image
            readURL(event)
            {
                this.imageProfileIsLoading = true
                  var input = event.srcElement;
                  if (input.files && input.files[0]) {
                var reader = new FileReader();
                  var vm = this
                reader.onload = function (e)
                {
                    $('.image-uploader-content img').attr('src', e.target.result);
                    vm.form.image_mise_en_avant = e.target.result;
                    //console.log(e.target.result)
                    vm.imageProfileIsLoading = false
                };
                reader.readAsDataURL(input.files[0]);
            }},
            //Charge l'image
            onUploadDocument(name,event)
            {

                  var input = event.srcElement;
                  if (input.files && input.files[0])
                   {
                    var reader = new FileReader();
                    var vm = this
                    reader.onload = function (e)
                    {

                            vm.form[name].fichier = e.target.result;
                            vm.form[name].nom_fichier=input.files[0].name
                            vm.form[name].hasFile=true

                    };
                    reader.readAsDataURL(input.files[0]);
                   }
            },
             //Retire l'image des
            removeImage(index)
            {
               this.form.images.splice(index,1)

            },
            //Charge les images de la galerie
            readURLGalerie(event)
            {
                  var input = event.srcElement;
                  this.imageGalleryIsLoading = true
                  if (input.files && input.files[0])
                  {

                      var index = 0
                      var vm = this
                      this.fileCounter = input.files.length
                      this.imageGalleryIsLoading = true
                      for(index;index<input.files.length;index++)
                      {
                        var reader = new FileReader();
                        reader.onload = function (e)
                        {
                            //$('.image-uploader-content img').attr('src', e.target.result);
                            //vm.form.image_mise_en_avant = e.target.result;
                            vm.form.images.push(e.target.result)
                            vm.fileCounter--

                        };
                        reader.readAsDataURL(input.files[index]);
                      }
                   }
            },
             registerFile(event)
            {
              this.form.images.push(event.dataURL)
              this.FileIsLoading = false
            },
            removedfileFromDropzone(file, error, xhr)
            {
                var oldSize = this.form.images.length
                this.form.images= this.form.images.filter(e => { return e !==file.dataURL })
                if(this.form.images.length != oldSize)
                {
                    this.FileLimit++
                }

            },
            fileAdded(event)
            {

                 
              var reader = new FileReader();
              var vm = this
              reader.onload = function (e)
              {
                    if(vm.FileLimit > 0)
                    {
                        vm.form.images.push(e.target.result)
                        vm.FileLimit--;
                    }
                    else
                    {
                        vm.$refs.dropzone.removeFile(event)
                    }
                   
            
              };
            
             reader.readAsDataURL(event);
             
       
              
            },
            maxFilesReached(file)
            {
              //console.log(file)
              //this.$refs.dropzone.removeFile(file)
            },
            onComplete()
            {

            },
            showModalOnCreate()
             {

                      this.modeEdit = false
                      this.$refs['inputModal'].show()

             },
             showModalOnEdit(entity)
             {
                  this.modeEdit = true
                  this.form.libelle = entity.libelle
                  this.form.id=entity.id
                  this.$refs['inputModal'].show()
             },
              reset()
             {
                  this.initForm()
             },

             // Events
             trackMarque(e)
             {
                 if(e!=null)
                 {
                   this.form.marque_id = e.id
                   this.modeles = e.modeles
                   this.modele=""
                   this.form.modele_id = ""
                 }
                 else
                 {
                   this.modele =""
                   this.form.modele_id = ""
                 }


             },
              trackModele(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },
            trackTM(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             }
        },
        components:
         {
          FormWizard,
          TabContent,WizardButton,WizardStep,
          vueDropzone: vue2Dropzone
         },
         watch:
         {
             "fileCounter":function(val)
             {
                 if(this.fileCounter==0 && this.imageGalleryIsLoading == true)
                 {
                     this.imageGalleryIsLoading = false
                 }
             },
            "OptionsIds":function(val)
             {
                 this.form.options = val
             },
             "form.marque_id" : function(value)
             {
                 if(value!="")
                 {
                  this.updateFormErrors("marque_id");
                 }

             },

             "form.modele_id" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("modele_id");
             },
            "form.type_motorisation_id" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("type_motorisation_id");
             }
             ,
            "form.boite_vitesse" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("boite_vitesse");
             }
             ,
            "form.type_vehicule_id" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("type_vehicule_id");
             }
         }

    }
</script>
<style lang="scss">
.wizard-header,.wizard-progress-with-circle {
    display:none !important;
}
.dataTables_info select {
    width: auto;
    display: inline-block;

        height: calc(1.5em + 1rem + 2px);
    padding-top: 0.5rem;
    padding-bottom: 0.5rem;
    padding-left: 1rem;
    font-size: 0.875rem;
    padding: 0.65rem 2rem 0.65rem 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    vertical-align: middle;
    background: #fff url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e") no-repeat right 1rem center/8px 10px;
    border: 1px solid #e2e5ec;
    border-radius: 0.25rem;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;

}
.vue-dropzone
{
    width: 100%;
    margin-top: 34px;
    min-height: 270px;
    position:relative;
    display: flex;
    -webkit-box-pack: center !important;
    justify-content: center !important;
    
}
.dz-message{
    width: 50%;
    margin: auto !important;
    position: absolute;
    top: 50%;
    left: 50%;
    -webkit-transform: translate(-50%,-50%);
    -ms-transform: translate(-50%,-50%);
    transform: translate(-50%,-50%);
}

.profile-image-preview {
    width: 300px !important;
    height: 240px !important;
}
.profile-image-preview img {
    width: inherit !important;
    height: inherit !important;
    -o-object-fit: cover;
    object-fit: cover;
}
</style>
